/*
 *
 *
 *
 */

#ifndef __PROCESSOR_H__
#define __PROCESSOR_H__

#include <testos/types.h>

struct processor_t {
	int stepping:4 ;
	int model:4 ;
	int family:4;
	int other:20;
} __attribute__ ((packed));

static inline unsigned int cpuid_eax(unsigned int op)
{
        unsigned int eax;
        __asm__ ("cpuid"
		: "=a" (eax)
		: "m" (op)
		: "bx", "cx", "dx");
        return eax;
}

static inline unsigned int cpuid_ebx(unsigned int op)
{
        unsigned int eax, ebx;
        __asm__ ("cpuid"
		: "=a" (eax), "=b" (ebx)
		: "m" (op)
		: "cx", "dx");
        return ebx;
}

static inline unsigned int cpuid_ecx(unsigned int op)
{
        unsigned int eax, ecx;
        __asm__ ("cpuid"
		: "=a" (eax), "=c" (ecx)
		: "m" (op)
		: "bx", "dx");
        return ecx;
}

static inline unsigned int cpuid_edx(unsigned int op)
{
        unsigned int eax, edx;
        __asm__ ("cpuid"
		: "=a" (eax), "=d" (edx)
		: "m" (op)
		: "bx", "cx");
        return edx;
}


#define PROC_GET_STEPPING(pr) 	pr & 0x0000000f
#define PROC_GET_MODEL(pr) 	pr & 0x000000f0
#define PROC_GET_FAMILY(pr) 	pr & 0x00000f00
#define PROC_GET_TYPE(pr) 	pr & 0x00002000

#endif
